<?php

namespace FireDrum;

if ( !defined( 'ABSPATH' ) ) {
	die();
}

require_once( 'et-core-api-email-provider-loader.class.php' );

class Email_Marketing_Divi {
	private static $instance = null;

	public static function instantiate() {
		if ( self::$instance === null ) {
			self::$instance = new self();
		}
		return self::$instance;
	}

	/**
	 * Class constructor.
	 */
	private function __construct() {
		Email_Marketing_ET_Core_API_Email_Provider_Loader::instantiate();

		add_action( 'admin_init', array( $this, 'on_admin_init' ) );
		add_action( 'init', array( $this, 'on_init' ) );
	}

	public static function upgrade($current_db_version) {
		Email_Marketing_ET_Core_API_Email_Provider_Loader::upgrade( $current_db_version );
	}

	public static function uninstall($wpdb) {
		Email_Marketing_ET_Core_API_Email_Provider_Loader::uninstall( $wpdb );
	}

	public function on_admin_init() {
		add_action( 'wp_ajax_' . Email_Marketing_Plugin::get_branding() . '_divi_admin_main_css', array (
			$this,
			'do_ajax_admin_main_css'
		) );
	}

	public function on_init() {
		if ( is_admin() ) {
			$this->init_admin();
		}
	}

	public function init_admin() {
		wp_enqueue_style( Email_Marketing_Plugin::get_branding() . '_divi_admin_main', add_query_arg( array( 'action' => Email_Marketing_Plugin::get_branding() . '_divi_admin_main_css', 'ver' => Email_Marketing_Plugin::get_version() ), admin_url( 'admin-ajax.php' ) ) );
	}

	public function do_ajax_admin_main_css() {
		header( 'Content-Type: text/css; charset=utf-8' );

		require( 'admin/css/main.css.php' );

		exit();
	}
}
