<?php

namespace FireDrum;

if ( !defined( 'ABSPATH' ) ) {
	die();
}

/**
 * Class Email_Marketing_GravityForms
 */
class Email_Marketing_GravityForms {
	private static $instance = null;

	public static function instantiate() {
		if ( self::$instance === null ) {
			self::$instance = new self();
		}
		return self::$instance;
	}

	public static function upgrade($current_db_version) {
		// No-op
	}

	public static function uninstall($wpdb) {
		// No-op
	}

	/**
	 * Class constructor.
	 */
	private function __construct() {
		$this->plugin = Email_Marketing_Plugin::instantiate();

		add_action( 'gform_loaded', array( $this, 'load' ), 5 );
	}

	/**
	 * If the Feed Add-On Framework exists, this add-on is loaded.
	 *
	 * @access public
	 * @static
	 */
	public static function load() {
		if ( !method_exists( '\\GFForms', 'include_feed_addon_framework' ) ) {
			return;
		}

		require_once( 'feed.class.php' );

		\GFAddOn::register( '\\' . Email_Marketing_Plugin::get_menu_branding() . '\\Email_Marketing_GravityForms_Feed' );
	}
}
