<?php

namespace FireDrum;

if ( !defined( 'ABSPATH' ) ) {
	die();
}

?>
(function($) {<?php
if ( $this->reCaptchaEnabled ) {
?>
	function initialize_recaptcha() {
		var signup_forms = [];

		$( '.<?php echo self::$branding; ?>_signup_form' ).each(function(index, form) {
			var $form = $( this );
			var reCaptchaInfo = {
				reCaptchaID: null,
				reCaptchaContainer: document.createElement( 'div' ),
				form: $form
			};
			form.appendChild( reCaptchaInfo.reCaptchaContainer );
			window['<?php echo self::$branding; ?>ReCaptchaCallback_' + index] = function(token) {
				ajax_submit( $form );
				grecaptcha.reset( $form.data( 'recaptcha-id' ) );
				$( 'iframe[title="recaptcha widget"]', signup_forms[index].reCaptchaContainer ).on( 'load', function() {
					var challengeParent = $( 'iframe[title="recaptcha challenge"]:first-child' ).parent();
					challengeParent.prepend( '<div class="<?php echo self::$branding; ?>-instructions"><table><tbody><tr><td class="invisible-text"><span>protected by <strong>reCAPTCHA</strong></span><div class="anchor-pt"><a href="https://www.google.com/intl/en/policies/privacy/" target="_blank">Privacy</a><span aria-hidden="true" role="presentation"> - </span><a href="https://www.google.com/intl/en/policies/terms/" target="_blank">Terms</a></div></td><td class="normal-footer"><div class="logo-large" role="presentation"><div class="logo-img logo-img-large"></div></div></td></tr></tbody></table></div>' );
					challengeParent.parent().attr( 'class', '<?php echo self::$branding; ?>-captcha-challenge' );
				} );
			}
			signup_forms.push( reCaptchaInfo );
		} );

		if ( signup_forms.length > 0 ) {
			window.<?php echo self::$branding; ?>ReCaptchaOnLoad = function(index, form) {
				for ( var i = 0; i < signup_forms.length; i++ ) {
					signup_forms[i].form.data( 'recaptcha-id', grecaptcha.render( signup_forms[i].reCaptchaContainer, {
						sitekey: '<?php echo $this->publicAppProperties['publicAppProperties']['reCaptchaSiteKey']; ?>',
						size: 'invisible',
						callback: '<?php echo self::$branding; ?>ReCaptchaCallback_' + i
					} ) );
					$( 'iframe[title="recaptcha widget"]', signup_forms[i].reCaptchaContainer ).on( 'load', function() {
						var challengeParent = $( 'iframe[title="recaptcha challenge"]:first-child' ).parent();
						challengeParent.prepend( '<div class="<?php echo self::$branding; ?>-instructions"><table><tbody><tr><td class="invisible-text"><span>protected by <strong>reCAPTCHA</strong></span><div class="anchor-pt"><a href="https://www.google.com/intl/en/policies/privacy/" target="_blank">Privacy</a><span aria-hidden="true" role="presentation"> - </span><a href="https://www.google.com/intl/en/policies/terms/" target="_blank">Terms</a></div></td><td class="normal-footer"><div class="logo-large" role="presentation"><div class="logo-img logo-img-large"></div></div></td></tr></tbody></table></div>' );
						challengeParent.parent().attr( 'class', '<?php echo self::$branding; ?>-captcha-challenge' );
					} );
				}
			};

			var reCaptcha = document.createElement( 'script' );
			reCaptcha.async = 'async';
			reCaptcha.defer = 'defer';
			reCaptcha.src = 'https://www.google.com/recaptcha/api.js?onload=<?php echo self::$branding; ?>ReCaptchaOnLoad&render=explicit';
			document.head.appendChild( reCaptcha );
		}
	}
<?php
}
?>
	function before_form(evt) {
		// Disable the submit button
		$( '.<?php echo self::$branding; ?>_signup_submit', this ).attr( 'disabled', true );

<?php
if ( $this->reCaptchaEnabled ) {
?>
		grecaptcha.execute( $( this ).data( 'recaptcha-id' ) );<?php
} else {
?>
		ajax_submit( $( this ) );<?php
}
?>

		evt.preventDefault();
		return false;
	}
	
	function ajax_submit( $form ) {
		$form.ajaxSubmit( {
			url: '<?php echo $this->ajax_url; ?>',
			type: 'POST',
			success: success_callback
		} );
	}

	function success_callback(data, status, xhr, $form) {
		if ( typeof $form === 'undefined' ) {
			// Using jQuery < 1.4
			$form = xhr;
		}

		// We may be in a modal dialog, so check for the modal container
		var modal_container = $form.closest( '.<?php echo self::$branding; ?>_modal' );

		// Re-enable the submit button
		$( '.<?php echo self::$branding; ?>_signup_submit', $form ).removeAttr( 'disabled' );

		// Put the response in the message div
		$( '.<?php echo self::$branding; ?>_message', $form ).html( data.message );

		// See if we're successful, if so, wipe the fields
		if ( data.success ) {
			$form[0].reset();

			if ( modal_container.length ) {
				$.cookie( '<?php echo self::$branding; ?>_modal_' + modal_container.data( 'modal-id' ), '1', {
					path: '/'
				} );
				$.magnificPopup.close();
			}
		}

		if ( !modal_container.length ) {
			$.scrollTo( $form.parent(), {
				offset: {
					top: -28
				}
			} );
		}
	}

	$( document )
		.on( 'submit', '.<?php echo self::$branding; ?>_signup_form', before_form )<?php
if ( $this->reCaptchaEnabled ) {
?>
		.on( '<?php echo self::$branding; ?>:modals_initialized', 'body', initialize_recaptcha )<?php
}
?>;
})( jQuery );
